LeetCode:找出并返回可以覆盖所有房屋的最小加热半径.

Winter is coming!Your first job during the contest is to design a standard heater with fixed warm
all the houses.
Now,you are given positions of houses and heaters on a horizontal line,find out a minimum radius 
of heaters so that all houses could be covered by those heaters.
So,your input will be the positions of houses and heaters separately,and your expected output will
be the minimum radius standard of heaters.

Note:
1.Numbers of houses and heaters you are given are non-negative and will not exceed 25000.
2.Positions of houses and heaters you are given are non-negative and will not exceed 10^9.
3.As long as a house is in the heaters' warm radius range,it can be warmed.
4.All the heaters follow your radius standard, and the warm radius will the same.

Example 1:
Input:houses=[1,2,3],heaters=[2]
Output:1
Explanation:The only heater was placed in the position 2,and if we use the radius 1 standard,
then all the houses can be warmed.

Example 2:
Input:houses=[1,2,3,4],heaters=[1,4]
Output:1
Explanation:The two heater was placed in the position 1 and 4.We need to use radius 1 standard,
then all the houses can be warmed.

题目大意:
冬季已经来临.你的任务是设计一个有固定加热半径的供暖器向所有房屋供暖.如今给出位于一条水平线上的房屋和供暖器的位置,找出可以
覆盖所有房屋的最小加热半径.因此给出房屋和供暖器的位置,请你找出并返回可以覆盖所有房屋的最小加热半径.

解题思路:
方法1:
暴力破解,先对heaters中的每个热水器统计到houses中的每个房屋的距离,存储在一个大小与houses相等的数组ans中,在统计过程中
若已经存在则取最小值,遍历完所有的heaters后.再枚举ans中选取最大值,则为覆盖房屋的最小加热半径.
超出时间限制.

方法2:
二分查找.在查找距离房子最近的供暖器的时候,先将供暖器进行排序,然后二分查找.其他思路和上面一致.

Go语言实现

package main

import (
	"fmt"
	"math"
	"sort"
)

//暴力破解,超时
func findRadiusOne(houses []int,heaters []int) int{
	ans:=make([]int,len(houses))
	for i,_:=range ans{
		ans[i]=math.MaxInt64
	}
	for i:=0;i<len(heaters);i++{
		for j:=0;j<len(houses);j++{
			ans[j]=min(ans[j],int(math.Abs(float64(houses[j]-heaters[i])))) //类型转换
			//直接abs函数 ,abs(houses[j]-heaters[i])
		}
	}
	res:=0
	for _,num:=range ans{
		res=max(res,num)
	}
	return res
}

func max(a,b int)int{
	if a>b{
		return a
	}
	return b
}

func min(a,b int)int{
	if a>b{
		return b
	}
	return a
}

//优化算法
func findRadiusTwo(houses []int,heaters []int) int{
	minRad:=0
	sort.Ints(heaters) //先对供暖器进行排序
	for _,house:=range houses{
		//遍历房子的坐标,维护heaters的最小半径
		heater:=findClosestHeater(house,heaters)//距离房子最近的供暖器
		rad:=heater-house

		if rad<0{
			rad=-rad
		}
		//全覆盖的供暖器最小半径,应达到最大的那个
		if rad>minRad{
			minRad=rad
		}
	}
	return minRad
}

func findClosestHeater(pos int,heaters []int)int{
	low,high:=0,len(heaters)-1
	//房子不在热水器范围内
	if pos<heaters[low]{
		return heaters[low]
	}
	if pos>heaters[high]{
		return heaters[high]
	}

	//二分查找
	for low<=high{
		mid:=(low+high)>>1
		if pos==heaters[mid]{
			return heaters[mid]
		}else if pos<heaters[mid]{
			high=mid-1
		}else{
			low=mid+1
		}
	}

	//判断距离两边的heaters哪个更近
	 if pos-heaters[high]<heaters[low]-pos{
	 	return heaters[high]
	 }
	return heaters[low]
}
func main(){
	houses,heaters:=[]int{1,5},[]int{2}
	fmt.Println(findRadiusOne(houses,heaters))
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组找出两个数的和等于目标值,并返回两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

路上的追梦人

您的鼓励就是我最大的动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值